C     Last change:  JRC   5 Mar 97    1:22 am
C-----------------------------------------------------------------------
C            INPUT-OUTPUT SUBROUTINES-2
C-----------------------------------------------------------------------
C--------1---------2---------3---------4---------5---------6---------7--
      Subroutine Read_PhasesAtom(K,N,iof)
C--------1---------2---------3---------4---------5---------6---------7--
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
cfree
      Character    aLine*132,FMTformat*132,FMTfields*80,aux*7
      Integer*4    nCarL,iErr,Line_Nb
      common/Line_count/Line_Nb
cfree
C
C---------------
C
C phase ****************************************************************
C phase *** READ AND PRINT FOR EACH ATOM
C phase ****************************************************************
C
C----- Skip for Profile Matching modes
        IF (iabs(JBT(K)).EQ.2.OR.iabs(JBT(K)).EQ.3) GOTO 240
C
        IOF=0
        IF(K.GT.1) THEN
          DO IIPHAS=2,K
            IOF = IOF + NATOM(IIPHAS-1)
          End Do
        End If
C
C-----  CRYSTAL STRUCTURE (NUCLEAR) ---------
C
        IF (JBT(K).EQ.0) THEN
C
          WRITE(i_Out,210)
  210     Format(/' => Initial parameters ==>'/
     +    ' Atom  Ntyp                 ',
     +    1Hx,9X,1Hy,9X,1Hz,9X,1HB,9X,'occ.',6X,'Op.in.  Op.fin. '/
     +    27X,3HB11,7X,3HB22,7X,3HB33,7X,3HB12,7X,3HB13,7X,3HB23)
C
          DO I=1,N
C
C         ------------------------------ FORMAT(BZ,2A4,8X,5F8.5,2I4/...)
            FMTfields = '44fffffiii'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  then
       call mess('             !!!!  W A R N I N G !!!! ')
       call mess(' If your atoms are ISOTROPIC remove betas and codes!')
       GoTo 99995
      endif
            READ(aLine,FMTformat)
     +        ATEXT(I+IOF), NTYP(I+IOF), (XL(I+IOF,J),J=1,5),
     +        (ISAP(I+IOF,J),J=1,2),n_t(i+iof)
C        ---------------------------------------------------------------
          WRITE(i_Out,'(1X,A4,1X,A4,12X,5F10.5,7X,2I5)')
     +       ATEXT(I+IOF), NTYP(I+IOF), (XL(I+IOF,J),J=1,5),
     +      (ISAP(I+IOF,J),J=1,2)
C
C         ------------------------------------ Format(.../16x,5F8.2/...)
            FMTfields = 'fffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
      if (iErr.ne.0)  then
       call mess('             !!!!  W A R N I N G !!!! ')
       call mess(' If your atoms are isotropic remove betas and codes!')
       GoTo 99995
      endif
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)  (A(I+IOF,J),J=1,5)
C         --------------------------------------------------------------
C
          WRITE(i_Out,'(15x,a,5F10.5)') 'Codes: ',(A(I+IOF,J),J=1,5)
C         ---------------------------------------- FORMAT(.../6F8.5/...)
        if(iabs(n_t(i+iof)).eq.2) then      !Reading Betas or U's if N_typ=2
            FMTfields = 'ffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (XL(I+IOF,J),J=13,18)
C         --------------------------------------------------------------
          WRITE(i_Out,'(15x,a,6F10.5)') 'Betas: ',(XL(I+IOF,J),J=13,18)
C
C         -------------------------------------------- FORMAT(.../6F8.2)
            FMTfields = 'ffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (A(I+IOF,J),J=13,18)
C         --------------------------------------------------------------
          WRITE(i_Out,'(15x,a,6F10.5)') 'Codes: ',(A(I+IOF,J),J=13,18)


        elseif(iabs(n_t(i+iof)).eq.4) then  !Reading form-factor params if N_typ=4
            II=12
          do ireadm=1,2
            II=II+7
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (XL(I+IOF,J),J=II,II+6)
C         --------------------------------------------------------------
        WRITE(i_Out,'(15x,a,7F10.5)') 'Formf: ',(XL(I+IOF,J),J=II,II+6)
C
C         -------------------------------------------- FORMAT(.../6F8.2)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (A(I+IOF,J),J=II,II+6)
C         --------------------------------------------------------------
        WRITE(i_Out,'(15x,a,7F10.5)') 'Codes: ',(A(I+IOF,J),J=II,II+6)
         end do
          endif                 ! n_t(i+iof).eq.2 or eq.4
C
          END DO      ! I=1,N   End reading of crystal structure data
C
C  Crystal Structure Model supplied by user
C
         ELSE IF (iabs(JBT(K)).EQ.4) THEN
c
      WRITE(i_Out,215)
  215 FORMAT(/' => Initial parameters ==>'//
     +' => The meaning of the following list of 15 atomic parameters'/
     +'    is defined above from subroutine STRMOD'/
     +/23H Atom  Ntyp            ,6X
     +,'P1',8X,'P2',8X,'P3',8X,'P4',8X,'P5',8X,'P6',8X,'P7',8X,'P8'/
     +29x,'P9',7X,'P10',7X,'P11',7X,'P12',7X,'P13',7X,'P14',7X,'P15'
     +,7x,'P16'/)
c
          DO I=1,N
          n_t(i+iof)=0
C
C         ------------------------------ FORMAT(BZ,2A4,8X,5F8.5,3F8.3/...)
            FMTfields = '44ffffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)
     +        ATEXT(I+IOF), NTYP(I+IOF), (XL(I+IOF,J),J=1,8)
C        ---------------------------------------------------------------
          WRITE(i_Out,'(1X,A4,1X,A4,12X,8F10.5)')
     +      ATEXT(I+IOF), NTYP(I+IOF), (XL(I+IOF,J),J=1,8)
C         ------------------------------------ Format(.../16x,8F8.2/...)
            FMTfields = 'ffffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)  (A(I+IOF,J),J=1,8)
C         --------------------------------------------------------------
            WRITE(i_Out,'(15X,a,8F10.2)')'Codes: ',(A(I+IOF,J),J=1,8)
C
C         ---------------------------------------- FORMAT(.../8F8.5/...)
            FMTfields = 'ffffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (XL(I+IOF,J),J=9,16)
C         --------------------------------------------------------------
          WRITE(i_Out,'(15x,a,8F10.5)')' P9--> ',(XL(I+IOF,J),j=9,16)
C
C         -------------------------------------------- FORMAT(.../7F8.2)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (A(I+IOF,J),J=9,15)
C         --------------------------------------------------------------
            WRITE(i_Out,'(15X,a,7F10.2)')'Codes: ',(A(I+IOF,J),J=9,15)
C
          END DO      ! I=1,N
C
C
        Else
          if(iabs(jbt(k)).ne.10) then !put condition for xtal+mag structure
C
C-----  Magnetic structure
          if(jbt(k).eq.1)WRITE(i_Out,220)
  220     FORMAT(/' => Initial parameters ==>'/
     +    ' Atom  Ntyp   R-Mag    ',6X,
     +    'x',9X,'y',9X,'z',9X,1HB,6X,'occ.',6X,
     +    ' Mxr       Myr       Mzr'/
     +    27X,'Mxi',7X,'Myi',7X,'Mzi',7X,'b11',7X,'b22',7X,'b33',
     +    '    Magnetic Phase')
          if(jbt(k).eq.-1)WRITE(i_Out,221)
  221     FORMAT(/' => Initial parameters ==>'/
     +    ' Atom  Ntyp   R-Mag    ',6X,
     +    'x',9X,'y',9X,'z',9X,1HB,6X,'occ.',6X,
     +    ' Momr     Phir     Thetr'/
     +    27X,'Moi',7X,'Phi',7X,'Thi',7X,'b11',7X,'b22',7X,'b33',
     +    '    Magnetic Phase')
          if(iabs(jbt(k)).eq.5)WRITE(i_Out,223)
  223     FORMAT(/' => Initial parameters ==>'/
     +    ' Atom  Ntyp   R-Mag    ',6X,
     +    'x',9X,'y',9X,'z',9X,1HB,6X,'occ.',6X,
     +    ' P6       P7        P8  '/
     +    27X,'P9 ',7X,'P10',7X,'P11',7X,'P13',7X,'P14',7X,'P15',
     +    7x,'P12')
C
          DO I=1,N
          n_t(i+iof)=1
C
C         ----------------------------- FORMAT(BZ,2A4,I4,1X,I2,1X,5F8.5,3F8.3)
            FMTfields = '44iiffffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)
     +        ATEXT(I+IOF),NTYP(I+IOF),IMAGR(I+IOF),IKV(I+IOF),
     +       (XL(I+IOF,J),J=1,8)
C         --------------------------------------------------------------
          WRITE(i_Out,'(1X,A4,1X,A4,3X,I4,2X,I2,1X,8F10.5)')
     +       ATEXT(I+IOF), NTYP(I+IOF),IMAGR(I+IOF),IKV(I+IOF),
     +      (XL(I+IOF,J),J=1,8)
C
C         ----------------------------------------- FORMAT(16X,8F8.2)
            FMTfields = 'ffffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (A(I+IOF,J),J=1,8)
C         --------------------------------------------------------------
            WRITE(i_Out,'(15X,a,8F10.2)')'Codes: ',(A(I+IOF,J),J=1,8)
C
C         ------------------------------------------------ FORMAT(7F8.5)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)(XL(I+IOF,J),J=9,11),
     +      (XL(I+IOF,J),J=13,15),XL(I+IOF,12)
C         --------------------------------------------------------------
          aux=' Imm-> '
          if(iabs(jbt(k)).eq.5) aux='P9-15->'
          WRITE(i_Out,'(15x,a,7F10.5)') aux, (XL(I+IOF,J),J=9,11),
     +      (XL(I+IOF,J),J=13,15),XL(I+IOF,12)
C
C         --------------------------------------------- FORMAT(...7F8.5)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)(A(I+IOF,J),J=9,11),
     +      (A(I+IOF,J),J=13,15),A(I+IOF,12)
C         --------------------------------------------------------------
          WRITE(i_Out,'(15x,a,7F10.5)')'Codes: ', (A(I+IOF,J),J=9,11),
     +      (A(I+IOF,J),J=13,15),A(I+IOF,12)
C
          END DO      ! I=1,N
C
C
          else  ! Now iabs(Jbt(k))=10 (jbt.eq.10)
c
          WRITE(i_Out,230)
  230     Format(/' => Initial parameters ==>'/
     +' Atom  Ntyp  Imag  Ikv      ','x',9X,'y',9X,'z',9X,'B',9X,'occ.'
     +,5x,'Icod')

          DO I=1,N
C
C         ----------------------------- FORMAT(BZ,2A4,I4,1X,I2,1X,5F8.5,3F8.3)
            FMTfields = '44iifffffi'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)
     +        ATEXT(I+IOF),NTYP(I+IOF),IMAGR(I+IOF),IKV(I+IOF),
     +       (XL(I+IOF,J),J=1,5),N_T(I+IOF)
C         --------------------------------------------------------------
          WRITE(i_Out,'(1X,A4,1X,A4,3X,I4,2X,I2,1X,5F10.5,i8)')
     +       ATEXT(I+IOF), NTYP(I+IOF),IMAGR(I+IOF),IKV(I+IOF),
     +      (XL(I+IOF,J),J=1,5),N_T(I+IOF)
C
C         ----------------------------------------- FORMAT(16X,8F8.2)
            FMTfields = 'fffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (A(I+IOF,J),J=1,5)
C         --------------------------------------------------------------
            WRITE(i_Out,'(15X,a,5F10.2)')'Codes: ',(A(I+IOF,J),J=1,5)
C
          IF(N_T(I+IOF).NE.0) THEN
            IF(N_T(I+IOF).EQ.1.OR.N_T(I+IOF).EQ.3) THEN
C         ------------------------------------------------ FORMAT(7F8.5)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)(XL(I+IOF,J),J=6,12)
C         --------------------------------------------------------------
          WRITE(i_Out,'(14x,a,7F10.5)')'Mag Par ',(XL(I+IOF,J),J=6,12)
C
C         --------------------------------------------- FORMAT(...7F8.5)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)(A(I+IOF,J),J=6,12)
C         --------------------------------------------------------------
            WRITE(i_Out,'(15X,a,7F10.2)')'Codes: ',(A(I+IOF,J),J=6,12)
            ENDIF    ! 1-3
            IF(N_T(I+IOF).EQ.2.OR.N_T(I+IOF).EQ.3) THEN
C         ------------------------------------------------ FORMAT(7F8.5)
            FMTfields = 'ffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)(XL(I+IOF,J),J=13,18)
C         --------------------------------------------------------------
          WRITE(i_Out,'(15x,a,6F10.5)')'Betas: ',(XL(I+IOF,J),J=13,18)
C
C         --------------------------------------------- FORMAT(...7F8.5)
            FMTfields = 'fffffff'
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)(A(I+IOF,J),J=13,18)
C         --------------------------------------------------------------
            WRITE(i_Out,'(15X,a,6F10.2)')'Codes: ',(A(I+IOF,J),J=13,18)
            ENDIF         ! 2-3
          ENDIF                    !end N_T ><0

          END DO      ! I=1,N
C
          Endif !Jbt(k).ne.10
        End If      ! IF (JBT(K).EQ.0.or.jbt(k).eq.4) THEN
  240   Continue
        return
99999 CALL STOP_COND(' End of file *.PCR ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      Call message(' Please check your *.PCR file at line: ',Line_Nb,
     + 0.0,1)
      CALL STOP_COND(' Format error ',1)
        end
C--------1---------2---------3---------4---------5---------6---------7--
      Subroutine Apply_Helixcons(K,N,iof)
C--------1---------2---------3---------4---------5---------6---------7--
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
      DIMENSION cosa(3)
      DATA RAD/0.0174532925/
       IF(.not.(iabs(JBT(K)).EQ.2.OR.iabs(JBT(K)).EQ.3)) Then
         if(jhelix(k).eq.1) then
          do i=1,3
          cosa(i)=cos(par(k,i+8)*rad)
          end do
         endif
         IANIS(K)=0

          DO I=1,N
          ipiof=I+iof
          IF(n_t(ipiof).eq.2.or.n_t(ipiof).eq.3) IANIS(K)=1
          IF(n_t(ipiof).eq.4) IANIS(K)=3
            DO J=1,nat_p
              X=A(I+IOF,J)
              IYY=INT(ABS(X)/10.)
              IF(IYY.GT.MSZ) GO TO 99996
              LP(I+IOF,J)=IYY
              A(I+IOF,J)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
      IF(ABS(XL(I+IOF,J)).NE.0.0.AND.J.GT.8.and.j.lt.12)IANIS(K)=2
            End Do
c
c  Apply constraints for the case JHELIX(k)=1
c
          IF(jbt(k).eq.1.and.JHELIX(K).EQ.1.and.lp(ipiof,8).ne.0) THEN
         x=XL(ipiof,6)*XL(ipiof,9)+XL(ipiof,7)*XL(ipiof,10)
         x=x+(XL(ipiof,6)*XL(ipiof,10)+XL(ipiof,7)*XL(ipiof,9))*cosa(3)
         x=x+XL(ipiof,8)*(XL(ipiof,9)*cosa(2)+XL(ipiof,10)*cosa(1))
         x1=XL(ipiof,8)+cosa(2)*XL(ipiof,6)+cosa(1)*XL(ipiof,7)
         XL(IPIOF,11)=-x/x1
         A(ipiof,11)=0.0
         LP(ipiof,11)=0
          ENDIF

          IF(jbt(k).eq.-1.and.JHELIX(K).EQ.1.and.lp(ipiof,7).ne.0) THEN
          if(abs(XL(ipiof,8)-XL(ipiof,11)).GT.90.0) THEN   !Tu-Tv>90
           XL(IPIOF,11)=XL(ipiof,8)+90.                    !Tv=Tu+90
           XL(IPIOF,10)=XL(IPIOF,7)                        !Pv=Pu
         else
           x1=cos(XL(ipiof,8)*rad)/sin(XL(ipiof,8)*rad)
           x2=cos(XL(ipiof,11)*rad)/sin(XL(ipiof,11)*rad)
           x3=x1*x2
             if(abs(x3).gt.1.0) then
              if(abs(x1).gt.0.0) then
                x2=1./x1
              endif
             endif
           XL(IPIOF,10)=XL(IPIOF,7)+ACOS(-x3)/rad
         endif
         A(ipiof,10)=0.0
         LP(ipiof,10)=0
          ENDIF

          End Do  !Atoms index I
c
        if(iabs(jbt(k)).eq.4) ianis(k)=1
C
        END IF      ! IF(.not.(iabs(JBT(K)).EQ.2.OR.iabs(JBT(K)).EQ.3)) Then
        return
99996 call message('                        Error in a code: ',0,X,2)
      call message('    The maximum number of parameters is: ',MSZ,0.,1)
      CALL STOP_COND(' Error in a code ',1)
        end          !End of Subroutine Print_CodesAtom(K)
C--------1---------2---------3---------4---------5---------6---------7--
      Subroutine Read_PhasesProf(K)
C--------1---------2---------3---------4---------5---------6---------7--
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
cfree
      Character    aLine*132,FMTformat*132,FMTfields*80
      Integer*4    nCarL,iErr,Line_Nb
      common/Line_count/Line_Nb
cfree
C
      COMMON      /CELLX/
     +      AA,B,C,ALPHA,BETA,GAMMA,AL(3,3),IMU
C
      DIMENSION ALI(3,3)
C
C
C phase ****************************************************************
C phase ***  PROFILE PARAMETERS
C phase ****************************************************************
C
        if(iabs(IRF(k)).eq.4) then
         ISMO(K)=0
         FMTfields = 'ffffff'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
c  !  Sc1       Sc2        Sc3        Sc4        Sc5        Sc6
         READ(aLine,FMTformat) (PAR(K,L1),L1=1,5),PAR(K,12)
        else
C       --------------------------------------- Format(BZ,G8.2,5F8.0,I4)
         FMTfields = 'ffffffi'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
c   !  Scale       Shape1      Bov     Str1     Str2     Str3    Strain-Model
         READ(aLine,FMTformat)
     +    PAR(K,1),PAR(K,17),PAR(K,2),(PAR(K,L1),L1=18,20),ISMO(K)
        endif
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.2)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        if(iabs(irf(k)).eq.4) then
          READ(aLine,FMTformat) (APAR(K,L2),L2=1,5),APAR(K,12)
        else
         READ(aLine,FMTformat)
     +    APAR(K,1),APAR(K,17),APAR(K,2),(APAR(K,L2),L2=18,20)
        endif
C       ----------------------------------------------------------------
C
C       -------------------------------------------- Format(BZ,7F8.2,I4)
        if(iabs(IRF(k)).eq.4) then
         ISI(K)=0
         FMTfields = 'fffffff'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
c !    Ext1      Ext2      Ext3      Ext4      Ext5      Ext6      Ext7
         READ(aLine,FMTformat) (PAR(K,L1),L1=13,19)
        else
         FMTfields = 'fffffffi'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
c    !      U      V       W        X       Y     GauSiz   LorSiz Size-Model
         READ(aLine,FMTformat)
     +    PAR(K,3),PAR(K,4),PAR(K,5),PAR(K,15),PAR(K,16),PAR(K,28),
     +    PAR(K,29),ISI(K)
        endif
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,7F8.2)
        FMTfields = 'fffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        if(iabs(irf(k)).eq.4) then
         READ(aLine,FMTformat) (APAR(K,L1),L1=13,19)
        else
         READ(aLine,FMTformat)
     +    APAR(K,3),APAR(K,4),APAR(K,5),APAR(K,15),APAR(K,16),
     +    APAR(K,28),APAR(K,29)
        endif
C       ----------------------------------------------------------------

         if(iabs(IRF(k)).ne.4 .and. NPRO(k).EQ.12) THEN
         FMTfields = 'fffff'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
c    !      Ud       Vd        Wd       Etad0       Xd
         READ(aLine,FMTformat)
     +    PAR(K,46),PAR(K,47),PAR(K,48),PAR(K,49),PAR(K,50)

        FMTfields = 'fffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat)
     +   APAR(K,46),APAR(K,47),APAR(K,48),APAR(K,49),APAR(K,50)

         ENDIF  !NPROF=12

C       ----------------------------------------------------------------
C     Read cell parameters
C       ----------------------------------------------- Format(BZ,6F8.0)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
c     !     a          b         c        alpha      beta       gamma
        READ(aLine,FMTformat) (PAR(K,I),I=6,11)
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.2)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (APAR(K,I),I=6,11)
        if(iabs(IRF(K)).eq.4) then
         do I=6,11
          APAR(K,I)=0.0
         end do
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.0)
         FMTfields = 'fffff'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
         READ(aLine,FMTformat) (PAR(K,L),L=35,39)  !Unused parameters
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.2)
         FMTfields = 'fffff'
         Line_Nb = Line_Nb +1
         Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
         if (iErr.eq.-1) GoTo 99999
         if (iErr.ne.0)  GoTo 99995
         READ(aLine,FMTformat)   (APAR(K,L),L=35,39)
C       ----------------------------------------------------------------
        else      !Now irf<>4
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.0)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
c   !  Pref1  Pref2   Asy1    Asy2    Asy3     Asy4
        READ(aLine,FMTformat) PAR(K,12),PAR(K,13),PAR(K,14),
     +                        (PAR(K,L),L=35,37)
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.2)
        FMTfields = 'ffffff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) APAR(K,12),APAR(K,13),APAR(K,14),
     +    (APAR(K,L),L=35,37)
C       ----------------------------------------------------------------
        endif !irf=4
        if(iuvw.eq.1) then
           FMTfields = 'fff'
           Line_Nb = Line_Nb +1
           Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
           if (iErr.eq.-1) GoTo 99999
           if (iErr.ne.0)  GoTo 99995
c    !Additional U,V,W parameters for Lambda2
           READ(aLine,FMTformat) (PAR(K,L),L=43,45)
           FMTfields = 'fff'
           Line_Nb = Line_Nb +1
           Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
           if (iErr.eq.-1) GoTo 99999
           if (iErr.ne.0)  GoTo 99995
           READ(aLine,FMTformat) (APAR(K,L),L=43,45)
        endif
C       ----------------------------------------------------------------
        if(NPRO(K).EQ.5.OR.NPRO(K).GT.8) then
C       ----------------------------------------------- Format(BZ,6F8.0)
          FMTfields = 'ffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
c    !Additional Shape parameters
          READ(aLine,FMTformat) (PAR(K,L),APAR(K,L),L=41,42)
C       ----------------------------------------------------------------
         endif !NPRO
C       ----------------------------------------------------------------
         if(JSOL(K).EQ.1) then
C       ----------------------------------------------- Format(BZ,6F8.0)
        FMTfields = 'fffii'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
c    !     AsyP    Shift1    Shift2  ModA ModS
        READ(aLine,FMTformat) (PAR(K,L),L=38,40),IASV(K),ISHIF(K)
C       ----------------------------------------------------------------
C
C       ----------------------------------------------- Format(BZ,6F8.2)
        FMTfields = 'fff'
        Line_Nb = Line_Nb +1
        Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
        if (iErr.eq.-1) GoTo 99999
        if (iErr.ne.0)  GoTo 99995
        READ(aLine,FMTformat) (APAR(K,L),L=38,40)
C       ----------------------------------------------------------------
           if(iabs(ISHIF(K)).eq.1) then
C       -----------------------------------------------------  Format(*)
          FMTfields = 'fff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
c  ! Shift-cos(1) or Shift-sin(-1) axis
          READ(aLine,FMTformat) (PSH(K,I),I=1,3)
C       ----------------------------------------------------------------
           endif  !ishift= +/- 1
         endif !Jsol
C
        IF(iabs(JBT(K)).EQ.2.AND.APAR(K,1).NE.0.) THEN
        call message(' Scale factor fixed for phase:',K,0.,1)
          apar(k,1)=0.0
        End If
C
        If(iabs(IRF(K)).ne.4) then
        if(ixunit.eq.1) then
        WRITE(i_Out,252) PAR(K,1),PAR(K,17),PAR(K,2),
     +    PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),
     +    (PAR(K,I),I=6,11),PAR(K,12),PAR(K,13),PAR(K,14),
     +    (PAR(K,L2),L2=35,37),(PAR(K,L1),L1=18,20),
     +    PAR(K,28),PAR(K,29)
  252   FORMAT(/' => Overall scale factor: ',G12.6,/,
     *    ' => T.O.F. Peak shape parameter h: ',F8.4,/,
     *    ' => Overall temperature factor: ',F12.5/
     *    ' => T.O.F. Peak shape parameters u2,u1,u0: ',3F12.5/
     *    ' => T.O.F. Peak shape parameter Xt,Yt: ',2F12.4/
     *    ' => Direct cell parameters: ',6F9.4,/
     *    ' => Preferred orientation parameters: ',2F8.4/
     *    ' => T.O.F. Peak shape parameter a0,b0,a1,b1: ',4F12.5/
     *    ' => Strain parameters s2,s1,s0: ',3F12.5/
     *    ' => Size   parameters z1,z0  : ',2F12.5)
        else
        WRITE(i_Out,250) PAR(K,1),PAR(K,17),PAR(K,2),
     +    PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),
     +    (PAR(K,I),I=6,11),PAR(K,12),PAR(K,13),PAR(K,14),
     +    (PAR(K,L2),L2=35,37),(PAR(K,L1),L1=18,20),
     +    PAR(K,28),PAR(K,29)
  250   FORMAT(/' => Overall scale factor: ',G12.6,/,
     *    ' => ETA (p-Voigt) OR M (Pearson VII): ',F8.4,/,
     *    ' => Overall temperature factor: ',F12.5/
     *    ' => Halfwidth U,V,W: ',3F12.5/
     *    ' => X and Y parameters: ',2F12.4/
     *    ' => Direct cell parameters: ',6F9.4,/
     *    ' => Preferred orientation parameters: ',2F8.4/
     *    ' => Asymmetry parameters     : ',4F12.5/
     *    ' => Strain parameters        : ',3F12.5/
     *    ' => Size   parameters        : ',2F12.5)
c     *    ' => Asymm. & Shift parameters: ',2(F12.5/),f12.5)
         endif
        if(iuvw.eq.1) then      !Additional U,V,W parameters for L2
         WRITE(i_Out,'(a,3f10.5)')' => U2,V2,W2 for lambda(2) :',
     +   (PAR(K,L1),L1=43,45)
        endif
      if(npro(k).eq.12) then
        WRITE(i_Out,'(a,3f10.5)')
     +   ' => Split pV right halfwidth parameters Ur,Vr,Wr: ',
     +   (PAR(K,L1),L1=46,48)
        WRITE(i_Out,'(a,2f10.5)')
     +   ' => Split pV right EtaR0 and Xr parameters: ',
     +   (PAR(K,L1),L1=49,50)
        WRITE(i_Out,'(a,2f10.5)')
     + ' => Left and right Par (FWHM ~ Par/tanT):',PAR(K,41),PAR(K,42)
      elseif(npro(k).eq.5) then
        WRITE(i_Out,'(a,2f10.5)')' => Further shape parameters :',
     +   PAR(K,41),PAR(K,42)
      elseif(npro(k).eq.13) then
        WRITE(i_Out,'(a,2f10.5)')
     +   ' => Further shape parameters (S_L and D_L):',
     +   PAR(K,41),PAR(K,42)
       WRITE(i_Out,'(a/a)')'    S_L is source width/detector distance',
     +                     '    D_L is detector width/detector distance'
      endif
      if(npro(k).eq.8.and.(par(k,15).lt.0.0.or.par(k,16).lt.0.0)) then
      call mess(' Input X and/or Y parameters negative!')
      call mess('                (value fixed at 0.001)')
       if(par(k,15).lt.0.0) par(k,15)=.001
       if(par(k,16).lt.0.0) par(k,16)=.001
      endif
        else
        WRITE(i_Out,251)
     +   (PAR(K,L1),L1=1,5),Par(K,12),(PAR(K,L2),L2=13,19),
     +   (PAR(K,I),I=6,11)
  251   FORMAT(/' => Scale factors: ',6G12.6,/,
     *    ' => Extinction  parameters: ',7F9.4/,
     *    ' => Direct cell parameters: ',6F9.4/)
        endif
        IF(ISI(K).NE.0) THEN
       WRITE(i_Out,'(A,I2,A/)')
     +  ' => The ',ISI(K),'th model for size is used'
         call comsize(ISI(K))
        ENDIF
C
        IF (IABS(ISI(K)).EQ.1) THEN
C       -----------------------------------------------------  Format(*)
          FMTfields = 'fff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (PSZ(K,I),I=1,3)
C       ----------------------------------------------------------------
          WRITE(i_Out,'(A,3F8.4/)')
     +      ' => Platelet(1) or Needle(-1) axis: ',(PSZ(K,I),I=1,3)
        End If
C
        IF(ISMO(K).NE.0) THEN
         WRITE(i_Out,'(A,I2,A/)')
     &   ' => The ',ISMO(K),'th model for strain is used'
         call comstra(ISMO(K))
        ENDIF
        IF(ISMO(K).EQ.7) THEN
C       ------------------------------------------------------ Format(*)
          FMTfields = 'fff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (PST(K,I),I=1,3)
cucu
C       ---------------------KKKKKKKKKKKKKKKK---------------------------
          WRITE(i_Out,'(A,3F8.4/)')
     +      ' => Microstrain axis: ',(PST(K,I),I=1,3)
        End If
        IF(ISMO(K).gt.8) THEN
C       ------------------------------------------------------ Format(*)
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (Par(K,I),I=21,25)
c
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (APar(K,I),I=21,25)
cucu
C       ----------------------------------------------------------------
        End If

C
        IF(IASV(K).NE.0) then
           WRITE(i_Out,'(/A,I2,A/)')
     + ' => The ',IASV(K),'th model for hkl-dependent Asymmetry is used'
           call comasy(IASV(K))
         write(i_out,'(/a,f10.5)')' => Asymmetry parameter: ',Par(K,38)
         write(i_out,'(a,f10.5/)')'                  Code : ',aPar(K,38)
        endif
        IF(ISHIF(K).NE.0) then
           WRITE(i_Out,'(/A,I2,A/)')
     + ' => The ',ISHIF(K),'th model for hkl-dependent Shift is used'
           call comshif(ISHIF(K))
         write(i_out,'(/a,2f10.5)')
     +    ' => Shift parameters: ',(Par(K,I),I=39,40)
         write(i_out,'(a,2f10.5/)')
     +    '              Codes : ',(aPar(K,I),I=39,40)
           if(iabs(ISHIF(K)).eq.1)  WRITE(i_Out,'(A,3F8.4/)')
     +      ' => Shift-cos(1) or Shift-sin(-1) axis: ',(PSH(K,I),I=1,3)
        endif
C*I
        IF(NVK(K).NE.0) THEN
          FMTfields = 'fff'
          DO I=1,NVK(K)
C         ---------------------------------------------------- Format(*)
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (PVK(K,I,J),J=1,3)
C         --------------------------------------------------------------
C
C         ---------------------------------------------------- Format(*)
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat) (AVK(K,I,J),J=1,3)
C         --------------------------------------------------------------
C
            WRITE(i_Out,260)I,(PVK(K,I,J),J=1,3)
            WRITE(i_Out,270)I,(AVK(K,I,J),J=1,3)
          End Do
        END IF
C
        IF(GENK(K).EQ.'Y') THEN
          DO I=1,NVK(K)
            L=NVK(K)+I
            DO J=1,3
              PVK(K,L,J)=-PVK(K,I,J)
              AVK(K,L,J)=-AVK(K,I,J)
            End Do
            WRITE(i_Out,260) L,(PVK(K,L,J),J=1,3)
            WRITE(i_Out,270) L,(AVK(K,L,J),J=1,3)
          End Do
          NVK(K)=2*NVK(K)
        END IF
C*F
c
c Check if the propagation vectors verify that k is equivalent to -k
c
      DO L=1,NVK(K)
      IBZ(K,L)=1        !It is supposed that k is equivalent to -k
      if(GENK(K).EQ.'Y') IBZ(K,L)=0
      do j=1,3
       au=2.*pvk(k,L,j)
       iau=0
       call Zbelong(au,iau)
       if(iau.eq.0) IBZ(k,L)=0     !If iau=1 IBZ=1
      end do
      end do

  260   Format(' => Vector [K]: ',I3,3F8.4)
  270   Format('          Code: ',I3,3F8.2)
C
C phase ****************************************************************
C phase ***  READING OF FURTHER PARAMETERS IN CASES ISTR><0 OR IFURT><0
C phase ****************************************************************
C
        IF (IFURT(K).ne.0) THEN
          FMTfields = '4ff'
          DO I=1,IFURT(K)
C         --------------------------------------- Format(A4,F12.4,F12.4)
            Line_Nb = Line_Nb +1
            Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
            if (iErr.eq.-1) GoTo 99999
            if (iErr.ne.0)  GoTo 99995
            READ(aLine,FMTformat)
     +      NAMEF(K,I),PAR(K,I+lastmpar),APAR(K,I+lastmpar)
C         --------------------------------------------------------------
          End Do
        End If
C
        IF(.not.(ISTR(K).EQ.0 .or. ISTR(K).EQ.2)) Then
C       ------------------------------------------------ Format(5G14.5)
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (PAR(K,J),J=18,22)
C       ----------------------------------------------------------------
C
C       ------------------------------------------------- Format(5F14.5)
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (APAR(K,J),J=18,22)
C       ----------------------------------------------------------------
C
C       ------------------------------------------------- Format(5G14.5)
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (PAR(K,J),J=23,27)
C       ----------------------------------------------------------------
C
C       ------------------------------------------------- Format(5F14.5)
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (APAR(K,J),J=23,27)
C       ----------------------------------------------------------------
C
        End If ! IF (.not.(ISTR(K).EQ.0 .or. ISTR(K).EQ.2)) Then
C
C
        IF (ISTR(K).ge.2) THEN
C       ----------------------------------------------------------------
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (PAR(K,J),J=29,34)
C       ----------------------------------------------------------------
C
C       ----------------------------------------------------------------
          FMTfields = 'fffff'
          Line_Nb = Line_Nb +1
          Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
          if (iErr.eq.-1) GoTo 99999
          if (iErr.ne.0)  GoTo 99995
          READ(aLine,FMTformat) (APAR(K,J),J=29,34)
C       ----------------------------------------------------------------
        End If       !  IF(ISTR(K).ge.2) THEN
C
C     ---- Start preliminary calculations
        AA=PAR(K,6)
        B=PAR(K,7)
        C=PAR(K,8)
        ALPHA=PAR(K,9)
        BETA=PAR(K,10)
        GAMMA=PAR(K,11)
        DO I=1,6
          SAVE(K,I)=PAR(K,I+5)
        End Do
        CALL CELL2
        DO I=1,3
          PAR(K,I+5)=AL(I,I)
        End Do
        PAR(K,9)=AL(2,3)
        PAR(K,10)=AL(1,3)
        PAR(K,11)=AL(1,2)
c       call matrix(AL,ALI,AUX,AUX,'INVERT')
        call matinv3(AL,ALI,ifail)
        if(ifail.eq.1) call stop_cond('Bad G*-metric tensor!',1)
        DO I=1,3
         DO J=1,3
          GD(K,I,J)=ALI(I,J)
         END DO
        END DO
C
C phase ****************************************************************
C phase ***  V.V of vectors PREF, PST & PSZ stored in the 4th component
C phase ****************************************************************
C
        PREF(K,4)=0.
        PST(K,4)=0.
        PSZ(K,4)=0.
        PSH(K,4)=0.
        DO I=1,3
          DO J=I,3
            PREF(K,4)=PREF(K,4)+AL(I,J)*PREF(K,I)*PREF(K,J)
            PST(K,4)=PST(K,4)+AL(I,J)*PST(K,I)*PST(K,J)
            PSZ(K,4)=PSZ(K,4)+AL(I,J)*PSZ(K,I)*PSZ(K,J)
            PSH(K,4)=PSH(K,4)+AL(I,J)*PSH(K,I)*PSH(K,J)
          End Do
        End Do
       return
99999 CALL STOP_COND(' End of file *.PCR ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      Call message(' Please check your *.PCR file at line: ',Line_Nb,
     + 0.0,1)
      CALL STOP_COND(' Format error ',1)
       end            !End of Subroutine Read_PhasesProf(K)
C--------1---------2---------3---------4---------5---------6---------7--
      Subroutine Print_CodesProf(K)
C--------1---------2---------3---------4---------5---------6---------7--
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
C phase ****************************************************************
C phase *** PRINT CODEWORDS FOR PROFILE PARAMETERS
C phase ****************************************************************
C
        IF(ISTR(K).EQ.0) THEN
          AST1=APAR(K,18)
          AST2=APAR(K,19)
          AST3=APAR(K,20)
          AS1=APAR(K,28)
          AS2=APAR(K,29)
        Else
          AST1=0.0
          AST2=0.0
          AST3=0.0
          AS1=0.0
          AS2=0.0
        End If
        if(iabs(IRF(K)).ne.4) then
        write(i_out,'(/a)')' ==> CODEWORDS FOR PROFILE PARAMETERS:'
        if(ixunit.eq.1) then
        WRITE(i_Out,301)  APAR(K,1),APAR(K,17),APAR(K,2),
     +    APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),
     +    (APAR(K,I),I=6,11),
     +    APAR(K,12),APAR(K,13),APAR(K,14),(APAR(K,L),L=35,37),
     +    AST1,AST2,AST3,AS1,AS2
  301   FORMAT(/' => Overall scale factor: ',f8.3,/,
     *    ' => T.O.F. Peak shape parameter 1: ',F8.3,/,
     *    ' => Overall temperature factor: ',F8.3/
     *    ' => T.O.F. Peak shape parameter 2,3,4: ',3F8.3/
     *    ' => T.O.F. Peak shape parameter 5,6: ',2F8.3/
     *    ' => Direct cell parameters: ',6F8.3,/
     *    ' => Preferred orientation parameters: ',2F8.3/
     *    ' => T.O.F. Peak shape parameter 7,8,9,10: ',4F8.3/
     *    ' => Strain parameters        : ',3F8.3/
     *    ' => Size   parameters        : ',2F8.3)
        else
        WRITE(i_Out,300)  APAR(K,1),APAR(K,17),APAR(K,2),
     +    APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),
     +    (APAR(K,I),I=6,11),
     +    APAR(K,12),APAR(K,13),APAR(K,14),(APAR(K,L),L=35,37),
     +    AST1,AST2,AST3,AS1,AS2
  300   FORMAT(/' => Overall scale factor: ',f8.3,/,
     *    ' => ETA (p-Voigt) OR M (Pearson VII): ',F8.3,/,
     *    ' => Overall temperature factor: ',F8.3/
     *    ' => Halfwidth U,V,W: ',3F8.3/
     *    ' => X and Y parameters: ',2F8.3/
     *    ' => Direct cell parameters: ',6F8.3,/
     *    ' => Preferred orientation parameters: ',2F8.3/
     *    ' => Asymmetry parameters     : ',4F8.3/
     *    ' => Strain parameters        : ',3F8.3/
     *    ' => Size   parameters        : ',2F8.3)
c     *    ' => Asymm. & Shift parameters: ',3F8.3/)
         endif
        if(iuvw.eq.1) then      !Additional U,V,W parameters for L2
         WRITE(i_Out,'(a,3f8.3)')' => CU2,CV2,CW2 for lambda(2) :',
     +   (APAR(K,L1),L1=43,45)
        endif
      if(npro(k).eq.12) then
        WRITE(i_Out,'(a,3f8.3)')
     +   ' => Split pV right halfwidth parameters CUr,CVr,CWr: ',
     +   (APAR(K,L1),L1=46,48)
        WRITE(i_Out,'(a,2f8.3)')
     +   ' => Split pV right CEtaR0 and CXr parameters: ',
     +   (APAR(K,L1),L1=49,50)
        WRITE(i_Out,'(a,2f8.3)')
     +' => Left and right CPar (FWHM~Par/TanT):',APAR(K,41),APAR(K,42)
      endif
      if(npro(k).eq.5) then
        WRITE(i_Out,'(a,2f8.3)')' => Further shape parameters :',
     +  APAR(K,41),APAR(K,42)
      endif
       else
        write(i_out,'(/a)')
     +  ' ==> CODEWORDS FOR Scale and Extinction PARAMETERS:'
        WRITE(i_Out,251)
     +  (APAR(K,L1),L1=1,5),(APAR(K,I),I=12,19)
  251   FORMAT(/' => Scale factors: ',6F8.3/,
     *    ' => Extinction  parameters: ',7F8.3/)
       endif
C
C phase ****************************************************************
C phase ***  PRINTING FURTHER PARAMETERS AND CODES
C phase ****************************************************************
C
      if(ismo(K).gt.8) then
          WRITE(i_Out,'(A/5G14.5/5G14.5)')
     +      ' => Additional strain parameters and codes: ',
     + (Par(K,I),I=21,25),(APar(K,L),L=21,25)
      endif
        IF(IFURT(K).ne.0) Then
          WRITE(i_Out,'(//A//)')
     +      ' => Further parameters defined by user: '
          DO I=1,IFURT(K)
            WRITE(i_Out,'((2X,A4,F12.4,F12.4))')
     +        NAMEF(K,I),PAR(K,I+LASTMPAR),APAR(K,I+LASTMPAR)
          End Do
          WRITE(i_Out,'(A/)') '  '
        End If
C
        IF(.not.(ISTR(K).EQ.0 .or. ISTR(K).EQ.2)) Then
          WRITE(i_Out,'(//A//)')
     +      ' => Generalized Strain parameters and codes'
          WRITE(i_Out,'(5g14.5/5f14.5)')
     +      (PAR(K,J),J=18,22),(APAR(K,J),J=18,22)
          WRITE(i_Out,'(5g14.5/5f14.5)')
     +      (PAR(K,J),J=23,27),(APAR(K,J),J=23,27)
        End If
C
        IF(ISTR(K).ge.2) Then
          WRITE(i_Out,'(//A//)')
     +      ' => Generalized Size parameters and codes'
          WRITE(i_Out,'(6g12.4/6f12.4)')
     +      (PAR(K,J),J=29,34),(APAR(K,J),J=29,34)
        End If
C
        DO I=1,MPAR
          X=APAR(K,I)
          IYY=INT(ABS(X)/10.)
          IF(IYY.GT.MSZ) GO TO 99996
          LPAR(K,I)=IYY
          APAR(K,I)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
        End Do
C*I
        DO I=1,NVK(K)
          DO J=1,3
            X=AVK(K,I,J)
            IYY=INT(ABS(X)/10.)
            IF(IYY.GT.MSZ) GO TO 99996
            LVK(K,I,J)=IYY
            AVK(K,I,J)=(ABS(X)-10.*FLOAT(IYY))*SIGN(1.,X)
          End Do
        End Do
C
        return
99996 call message('                        Error in a code: ',0,X,2)
      call message('    The maximum number of parameters is: ',MSZ,0.,1)
      CALL STOP_COND(' Error in a code ',1)
        end                  !End of Subroutine Print_CodesProf(K)
C--------1---------2---------3---------4---------5---------6---------7--
      Subroutine Read_Constrain(K)
C--------1---------2---------3---------4---------5---------6---------7--
      INCLUDE      'ful0.inc'
      INCLUDE      'ful1.inc'
      INCLUDE      'ful2.inc'
cfree
      Character    aLine*132,FMTformat*132,FMTfields*80
      Integer*4    nCarL,iErr,Line_Nb
      common/Line_count/Line_Nb
cfree
      logical hexa
      Integer  Mod6
      common/SymOpda/Mod6(36,3,3)
      Character IntSymOh*14,Xoh*10,IntSymD6h*14,Xd6h*14
      common/SymOpsy/IntSymOh(48),Xoh(48),IntSymD6h(24),Xd6h(24)
C*F
C phase ****************************************************************
C phase *** READ CONSTRAINTS
C phase ****************************************************************
C
      IF(NDIC(K).NE.0) THEN
         WRITE(I_out,'(/A,I3/)')
     +        ' => Constraints on distances for phase',K
         WRITE(i_sum,'(A,I3)')
     +        ' => Constraints on distances for phase',K
         DO I=1,Ndic(K)
C       ----------------------------------------------------------------
           FMTfields = '44ifffff'
           Line_Nb = Line_Nb +1
           Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
           if (iErr.eq.-1) GoTo 99999
           if (iErr.ne.0)  GoTo 99995
           READ(aLine,FMTformat) (CATOD(j,K,I),j=1,2),Isymc(K,I),
     +     (transl(j,K,I),j=1,3), DIO(K,I),SDIO(K,I)
           if(sdio(k,i).lt.1.e-08) sdio(k,i)=0.001
C       ----------------------------------------------------------------
           hexa=.false.
           if(iabs(Isymc(K,i)).gt.24) hexa=.true.
           WRITE(i_out,'(A,A4,A,A4,a,F9.5,A,F9.5)')
     +     '    Distance between ',CATOD(1,K,I),' and ', CATOD(2,K,I),
     +     ' is ',DIO(K,I),
     +     ' with standard error: ',SDIO(K,I)

        WRITE(i_out,'(a/a)')
     +' -> The following operation will be applied to the second atom:',
     +'    ITnum  Rotation part       Associated Translation'

      if(hexa) then
        j=iabs(Isymc(K,i))-24
        if(Isymc(K,i).lt.0) j=j+12
        WRITE(i_out,'(a,i2,a,a14,a,3f8.4,a)') '     (',j,') ',
     +            Xd6h(j),' + {',(transl(m,k,i),m=1,3),'}'
        else
       j=iabs(Isymc(K,i))
       if(Isymc(K,i).lt.0) j=j+24
        WRITE(i_out,'(a,i2,a,a14,a,3f8.4,a)') '     (',j,') ',
     +            Xoh(j),' + {',(transl(m,k,i),m=1,3),'}'
        endif
           WRITE(i_sum,'(A,A4,A,A4,a,F9.5,A,F9.5)')
     +     '    Distance between ',CATOD(1,K,I),' and ', CATOD(2,K,I),
     +     ' is ',DIO(K,I),
     +     ' with standard error: ',SDIO(K,I)
         END DO
           WRITE(i_sum,'(A)')
     +      '    (See output file *.OUT for symmetry details)'
      ENDIF             !  End NDIC (constraints on distances)
c--------------------------------------------------------------------------
      IF(NMAGC(K).NE.0) THEN
         WRITE(I_out,'(/A,I3/)')
     +        ' => Constraints on magnetic moments for phase',K
         WRITE(i_sum,'(A,I3)')
     +        ' => Constraints on magnetic moments for phase',K
         DO I=1,NMAGC(K)
C       ----------------------------------------------------------------
           FMTfields = '2ff'
           Line_Nb = Line_Nb +1
           Call FindFMT(i_Pcr,aLine,FMTfields,FMTformat,nCarL,iErr)
           if (iErr.eq.-1) GoTo 99999
           if (iErr.ne.0)  GoTo 99995
           READ(aLine,FMTformat) CMATOM(K,I),SMO(K,I),SSMO(K,I)
C       ----------------------------------------------------------------
           WRITE(i_out,'(A,A2,A,F8.3,A,F8.5/)')
     +     '    Moment of ',CMATOM(K,I),' is ', SMO(K,I),
     +     ' with standard error: ',SSMO(K,I)
           WRITE(i_sum,'(A,A2,A,F8.3,A,F8.5/)')
     +     '    Moment of ',CMATOM(K,I),' is ', SMO(K,I),
     +     ' with standard error: ',SSMO(K,I)
         END DO
      ENDIF             !IF(NMAGC(K).NE.0) THEN
c
c     End of reading constraints
c
      return
99999 CALL STOP_COND(' End of file *.PCR ',1)
99995 Call FindFMT_Err(iErr,aLine,nCarL)
      Call message(' Please check your *.PCR file at line: ',Line_Nb,
     + 0.0,1)
      CALL STOP_COND(' Format error ',1)
      end                        !End of Subroutine Read_Constrain(K)
